import time
import pandas as pd

# Public Key Index Search (pubkey->userid)
class PubKeySearch: 
    # Build inverted pubkey index (pubkey->userid) 
    # WARNING: 1-based indexing by the
    # uic code makes it complicated to index to the user correctly
    def __init__(self, pub_keys, userkey_list): 
        t = time.time()

	all_pks, all_vals = [], []
	for idx,userkey in enumerate(userkey_list): 
	    pks = pub_keys.ix[userkey]['public_key_string'].values
	    all_pks.extend(pks)
	    
	    # +1 for (None), and +1 for 1-based indexing
	    all_vals.extend([idx] * len(pks)) 

        self.pubkey_to_user = dict(zip(all_pks,all_vals))
        print 'Constructing inverted pubkey index took ', time.time() - t, 's\n'

    def query(self, pk): 
        if pk in self.pubkey_to_user:
            return self.pubkey_to_user[pk]
        return None
