#!/usr/bin/python

'''
# TODO: license

This script requires a twitter_config file with the following lines: 

export TWITTER_CONSUMER_KEY='fill-in'
export TWITTER_CONSUMER_SECRET='fill-in'
export TWITTER_ACCESS_TOKEN='fill-in' export
TWITTER_ACCESS_TOKEN_SECRET='fill-in'

You will need to register on dev.twitter.com and apply for an application to get
these credentials. Once you've written these to the twitter_config file, run the script as: 
python twitter_scraper.py

tweepy should pull several records and save bitcoin addresses with their corresonding twitter user details.
'''

from commands import getoutput as cmd

cmd('export twitter_config')
TWITTER_CONSUMER_KEY = cmd('echo $TWITTER_CONSUMER_KEY')
TWITTER_CONSUMER_SECRET = cmd('echo $TWITTER_CONSUMER_SECRET')
TWITTER_ACCESS_TOKEN = cmd('echo $TWITTER_ACCESS_TOKEN')
TWITTER_ACCESS_TOKEN_SECRET = cmd('echo $TWITTER_ACCESS_TOKEN_SECRET')

import tweepy
import optparse
import sys
import time

api = tweepy.API()
active_queues = []
        
def parseOptions():
    parser = optparse.OptionParser()
    parser.add_option("-k", "--consumer_key", type="string", dest="consumer_key", help="Twitter consumer key for OAuth authentication", default=TWITTER_CONSUMER_KEY)
    parser.add_option("-K", "--consumer_secret", type="string", dest="consumer_secret", help="Twitter consumer secret", default=TWITTER_CONSUMER_SECRET)
    parser.add_option("-t", "--access_token", type="string", dest="access_token", help="Twitter access token", default=TWITTER_ACCESS_TOKEN)
    parser.add_option("-T", "--access_token_secret", type="string", dest="access_token_secret", help="Twitter access token secret", default=TWITTER_ACCESS_TOKEN_SECRET)
    parser.add_option("-q", "--query", type="string", dest="query", help="Comma-separated list of keywords", default="twitter")
    parser.add_option("-l", "--log", type="string", dest="log", help="Output log of streaming data", default="/tmp/stream.log")
    (options, _) = parser.parse_args()
    if options.consumer_key == '' or options.consumer_secret == '':
        parser.error("Twitter consumer key and consumer secret are mandatory")
    if options.access_token == '' or options.access_token_secret == '':
        parser.error("Twitter access token and access token secret are mandatory")
    return options
        
if __name__ == '__main__':
    options = parseOptions()
    auth = tweepy.OAuthHandler(options.consumer_key, options.consumer_secret)    
    auth.set_access_token(options.access_token, options.access_token_secret)

    api = tweepy.API(auth)
    for tweet in tweepy.Cursor(api.search,
                               q="bitcoin donate",
                               count=10,
                               result_type="recent",
                               include_entities=True,
                               lang="en").items():
        # print tweet.created_at, tweet.text
        print 'author: ', tweet.author.name, tweet.author.screen_name
        print 'user: ', tweet.author.location
        print 'id: ', tweet.id
        print 'coordinates: ', tweet.coordinates
        print 'text: ', tweet.text
        break

